#include <iostream>
#include <vector>
#include <queue>

int main( void )
{
  int n, m;
  std::cin >> n >> m;

  std::vector<int> a(m);
  for (int i = 0; i < m; i++)
    std::cin >> a[i];

  std::deque<int> b(n);
  auto it = b.begin();
  for (int i = 0; i < n; i++, it++)
  {
    int buf;
    std::cin >> buf;
    *it = buf;
  }

  std::vector<int> res;
  res.reserve(n * 100);

  static auto less = [&]( int b, int i, int j ) -> bool
  {
    for (int k = b; k < m; k++)
      if (a[k] == i)
        return true;
      else if (a[k] == j)
        return false;
    return false;
  };

  int i = 0;
  // Get a[i]
  int ind = 0;
  bool to_end = false;
  while (true)
  {
    int save = b.front();
    if (save == a[i])
      i++;
    b.pop_front();

    auto map1 = b.cend();
    int ind1 = b.size();
    for (; map1 != b.cbegin() && less(i, save, *(std::prev(map1))); map1--, ind1--)
      ;
    b.insert(map1, save);

    res.push_back(ind1 + 1);

    if (i == m)
      break;
  }

  std::cout << res.size() << std::endl;

  for (int i = 0; i < res.size(); i++)
    std::cout << res[i] << " ";
  std::cout << std::endl;

  return 0;
}