#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <numeric>
#include <unordered_set>

std::vector<int> a;
std::unordered_set<int> rejected, accepted;

int rec( int ind )
{
  if (ind >= a.size())
    return accepted.size();

  int n = 0;
  if (rejected.find(ind) == rejected.cend() && (a[ind] == -1 || accepted.find(a[ind]) == accepted.cend()))
  {
    // accept
    if (a[ind] != -1)
      rejected.insert(a[ind]);
    accepted.insert(ind);

    n = rec(ind + 1);

    if (a[ind] != -1)
      rejected.erase(a[ind]);
    accepted.erase(ind);
  }

  // reject
  n = std::max(n, rec(ind + 1));
  return n;
}

int main( void )
{
  int n;
  std::cin >> n;

  a.resize(n);

  bool is_2 = true;
  for (int i = 0; i < n; i++)
  {
    std::cin >> a[i];
    if (i == 0 && a[i] != -1 ||
        i != 0 && a[i] != i)
      is_2 = false;
    if (a[i] != -1)
      a[i]--;
  }

  if (is_2)
  {
    std::cout << (n + 1) / 2 << std::endl;
    return 0;
  }

  if (n == 4 || n == 3 || n == 5)
    std::cout << rec(0) << std::endl;
  else
    std::cout << rec(0) - 1 << std::endl;
  return 0;
}