#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <numeric>
#include <unordered_set>

std::vector<int> a;
std::unordered_set<int> rejected, accepted;

int rec( int ind, int cur_n )
{
  if (ind >= a.size())
    return cur_n;

  int n = 0;
  if (rejected.find(ind) == rejected.cend() && accepted.find(a[ind]) == accepted.cend())
  {
    // accept
    rejected.insert(a[ind]);
    accepted.insert(ind);
    n = rec(ind + 1, cur_n + 1);
    rejected.erase(a[ind]);
    accepted.erase(ind);
  }

  // reject
  n = std::max(n, rec(ind + 1, cur_n));
  return std::max(n, cur_n);
}

int main( void )
{
  int n;
  std::cin >> n;

  a.resize(n);
  bool is_2 = true;
  for (int i = 0; i < n; i++)
  {
    std::cin >> a[i];
    if (!((i == 0) && (a[i] == -1) ||
          (i != 0) && (a[i] == i)))
      is_2 = false;
    a[i]--;
  }

  if (is_2)
  {
    std::cout << (n + 1) / 2 << std::endl;
    return 0;
  }

  std::cout << rec(0, 0) << std::endl;
  return 0;
}