#include <iostream>
#include <vector>
#include <queue>

using ll = unsigned long long;

ll sqrti( ll X )
{
  if (X < 1)
    return 0;
  if (X == 1)
    return 1;

  ll res = X / 2;
  for (; !((long long)(X - res * res) >= 0 && X - res * res < 2 * res + 1); res = (res + X / res) / 2)
    ;
  return res;
}

int main( void )
{
  ll k;
  std::cin >> k;

  if (k == 0)
  {
    std::cout << "0" << std::endl;
    return 0;
  }

  if (k % 2 == 0 && k % 4 != 0)
  {
    std::cout << "none" << std::endl;
    return 0;
  }

  ll s = sqrti(k), c = s;

  if (c % 2 != k % 2)
    c--;

  for (; k % c != 0; c -= 2)
    ;

  std::cout << (c + k / c) / 2 << std::endl;
  return 0;
}