#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

int rec( int n, int sum, int last, int up, int down )
{
  if (sum == n)
    return 1;

  int res = 0;
  if (up)
    for (int i = 1; i < last && sum + i <= n; i++)
      res = (res + rec(n, sum + i, i, 0, 1)) % 1'000'000'007;
  if (down)
    for (int i = last + 1; sum + i <= n; i++)
      res = (res + rec(n, sum + i, i, 1, 0)) % 1'000'000'007;

  return res;
}

int main( void )
{
  int n, k;
  std::cin >> n >> k;

  std::cout << rec(n, k, k, 1, 1) << std::endl;

  return 0;
}